clc
clear
close all
pxy = [1 1 1 0 0 0;0 0 0 1 1 1];
py = [1/8;2/8;3/8;1/8;1/16;1/16];
px = pxy*py;
[h1,h2,h3]=svd(pxy);
Mh = h3(:,1:2)';
Bh = Mh*py;
Mh12 = Mh(:,[1 2])^(-1)*Bh;
Mh13 = Mh(:,[1 3])^(-1)*Bh;
Mh14 = Mh(:,[1 4])^(-1)*Bh;
Mh23 = Mh(:,[2 3])^(-1)*Bh;
Mh24 = Mh(:,[2 4])^(-1)*Bh;
Mh34 = Mh(:,[3 4])^(-1)*Bh;
t = Mh14(1);
p = Mh14(2);
a = ((Mh13(1))*log(Mh13(1))+(Mh13(2))*log(Mh13(2)))/log(2);
f4 = [-1 -1 -1 -1 -1 -1 -1 -1 -1].';
Aeq4 = [t t t 0 0 0 0 0 0;
       0 0 0 t t t  0 0 0;  
       0 0 0 0 0 0 t t t;
       p 0 0 p 0 0 p 0 0;
       0 p 0 0 p 0 0 p 0;
       0 0 p 0 0 p 0 0 p
];
beq4 = [py(1) py(2) py(3) py(4) py(5) py(6)].';
A4 = [-1 0 0 0 0 0 0 0 0;
     0 -1 0 0 0 0 0 0 0;
     0 0 -1 0 0 0 0 0 0;
     0 0 0 -1 0 0 0 0 0;
     0 0 0 0 -1 0 0 0 0;
     0 0 0 0 0 -1 0 0 0;
     0 0 0 0 0 0 -1 0 0;
     0 0 0 0 0 0 0 -1 0;
     0 0 0 0 0 0 0 0 -1
];
b4 = zeros(9,1);
options = optimoptions('linprog','Algorithm','interior-point-legacy','Display','iter')
[y4,fval4]=linprog(f4,A4,b4,Aeq4,beq4,[],[],[],'options')
hy = -(py(1)*log(py(1))+py(2)*log(py(2))+py(3)*log(py(3))+py(4)*log(py(4)))/log(2)
hy-fval4
k = -(y4(1)*log(y4(1))+y4(4)*log(y4(4))+y4(6)*log(y4(6))+y4(6)*log(y4(6))+y4(8)*log(y4(8))+y4(9)*log(y4(9)))/log(2)